/*
** PHREL
** $Id: data_hash.h,v 1.12 2013/04/21 02:29:09 sella Exp $
** Copyright (c) 2004-2013 James M. Sella. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

#ifndef __DGS_DATA_HASH_H
#define __DGS_DATA_HASH_H

#ifdef HAVE_CONFIG_H
   #include <config.h>
#endif

#include "phrel.h"

#include <arpa/inet.h>

#define HASH_WIDTH 249989 /* Must be prime number. */
//#define HASH_DEBUG

struct hash_entry_t {
	struct data_t *data;
	struct hash_entry_t *next;
};

struct hash_key_t {
	struct hash_entry_t *entry;
	unsigned int depth;
};

/* Public functions */
void hash_init(void);
void hash_free(void);
void hash_add(struct sockaddr_storage *key, struct data_t *data);
int hash_del(struct sockaddr_storage *key);
struct data_t* hash_find(struct sockaddr_storage *key);
struct data_t* hash_index(unsigned long index);
int hash_stats_print(void);
int hash_stats(char* stats, size_t len);

#endif

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim: noet ts=3 sw=3
*/
